import 'package:jaguar_serializer/jaguar_serializer.dart';
import 'package:star_xms/src/domain/list_entity.dart';

part 'list_entity.jser.dart';

@GenSerializer()
class JserListEntitySerializer extends Serializer<JserListEntity> with _$JserListEntitySerializer{}

class JserListEntity extends ListEntity<dynamic> {

  ListEntity<T> swapAsPass<T>() {
    ListEntity<T> entity = ListEntity<T>();
    entity.status = status;
    entity.msg = msg;
    if (result != null) {
      entity.result = List<T>.generate(result.length, (int index) {
        return result[index] as T;
      });
    }
    return entity;
  }

  ListEntity<T> swapAsMap<T>(Serializer<T> serializer) {
    ListEntity<T> entity = ListEntity<T>();
    entity.status = status;
    entity.msg = msg;
    if (result != null) {
      entity.result = List<T>.generate(result.length, (int index) {
        return serializer.fromMap(result[index] as Map<dynamic, dynamic>);
      });
    }
    return entity;
  }
}
