import 'package:jaguar_serializer/jaguar_serializer.dart';
import 'package:star_xms/src/domain/page_entity.dart';
import 'package:star_xms/src/domain/page.dart';

part 'page_entity.jser.dart';

@GenSerializer()
class JserPageEntitySerializer extends Serializer<JserPageEntity>
    with _$JserPageEntitySerializer {}

class JserPageEntity extends PageEntity<dynamic> {
  PageEntity<T> swapAsPass<T>() {
    PageEntity<T> entity = PageEntity<T>();
    entity.status = status;
    entity.msg = msg;
    entity.page = page;
    if (result != null) {
      entity.result = List<T>.generate(result.length, (int index) {
        return result[index] as T;
      });
    }
    return entity;
  }

  PageEntity<T> swapAsMap<T>(Serializer<T> serializer) {
    PageEntity<T> entity = PageEntity<T>();
    entity.status = status;
    entity.msg = msg;
    entity.page = page;
    if (result != null) {
      entity.result = List<T>.generate(result.length, (int index) {
        return serializer.fromMap(result[index] as Map<dynamic, dynamic>);
      });
    }
    return entity;
  }
}
