import 'package:jaguar_serializer/jaguar_serializer.dart';
import 'package:star_xms/src/domain/result_entity.dart';

part 'result_entity.jser.dart';

@GenSerializer()
class JserResultEntitySerializer extends Serializer<JserResultEntity> with _$JserResultEntitySerializer{}

class JserResultEntity extends ResultEntity<dynamic> {

  ResultEntity<T> swapAsPass<T>() {
    ResultEntity<T> entity = ResultEntity<T>();
    entity.status = status;
    entity.msg = msg;
    entity.result = result != null ? result as T : null;
    return entity;
  }

  ResultEntity<T> swapAsMap<T>(Serializer<T> serializer) {
    ResultEntity<T> entity = ResultEntity<T>();
    entity.status = status;
    entity.msg = msg;
    entity.result = result != null ? serializer.fromMap(result as Map<dynamic, dynamic>) : null;
    return entity;
  }
}
