import 'package:jaguar_serializer/jaguar_serializer.dart';

part 'entity.jser.dart';

@GenSerializer()
class EntitySerializer extends Serializer<Entity> with _$EntitySerializer {}

class Entity {
  static const int STATUS_OK = 0;
  static const int STATUS_FAIL = 1;

  /// 0:成功 1：失败 大于等于0是表示服务端返回异常；小于0表示特定异常
  int status;
  String msg;

  bool isOK() {
    return status == STATUS_OK;
  }

  bool isServerError() {
    return status > 0;
  }

  bool isSpecialError() {
    return status < 0;
  }
}
