import 'package:jaguar_serializer/jaguar_serializer.dart';

part 'page.jser.dart';

@GenSerializer()
class PageSerializer extends Serializer<Page> with _$PageSerializer {}

class Page {
  static const int PAGE_START = 0;

  /// 每页条数
  int num;

  /// 起始条数，从零开始
  int start;

  /// 总条数
  int total;

  /// 下一页的起始条数
  int nextStart() {
    return start + num;
  }

  bool isEnd() {
    return nextStart() >= total;
  }
}
