import 'package:fake_http/fake_http.dart';

class HttpXmsException implements Exception {
  HttpXmsException(
    Response response,
  )   : _code = response.code(),
        _message = response.message(),
        _response = response;

  final int _code;
  final String _message;
  final Response _response;

  int code() {
    return _code;
  }

  String message() {
    return _message;
  }

  Response response() {
    return _response;
  }

  @override
  String toString() {
    return 'HTTP $_code $_message';
  }
}
