import 'package:fake_http/fake_http.dart';
import 'package:flutter/foundation.dart';
import 'package:star_xms/src/interceptor/cache_constants.dart';

/// 应用层拦截器
///
/// 区分用户缓存
class CacheSplitInterceptor implements Interceptor {
  CacheSplitInterceptor(
    AsyncValueGetter<String> token,
  ) : _token = token;

  final AsyncValueGetter<String> _token;

  @override
  Future<Response> intercept(Chain chain) async {
    Request originalRequest = chain.request();
    String userID = await _token();
    if (userID == null || userID.isEmpty) {
      return await chain.proceed(originalRequest);
    }
    return await chain.proceed(originalRequest
        .newBuilder()
        .url(originalRequest
            .url()
            .newBuilder()
            .addQueryParameter(CacheConstants.QUERY_CACHE_SPLIT,
                hex.encode(md5.convert(utf8.encode(userID)).bytes))
            .build())
        .build());
  }
}
