import 'package:flutter/widgets.dart';
import 'package:meta/meta.dart';
import 'package:star_xms/src/domain/entity.dart';
import 'package:star_xms/src/localizations/xms_localizations.dart';
import 'package:star_xms/src/mvp/base_contract.dart';

abstract class SSOView {
  Future<dynamic> onUnauthorized();
}

abstract class XmsModel extends BaseModel {}

abstract class XmsView extends BaseView {}

abstract class XmsPresenter<V extends XmsView> extends BasePresenter<V> {
  /// {State#initState}
  XmsPresenter(
    BuildContext context,
    V view,
  )   : _requestError = XMSLocalizations.of(context).requestError,
        _serverError = XMSLocalizations.of(context).serverError,
        _networkError = XMSLocalizations.of(context).networkError,
        super(view);

  final String _requestError;
  final String _serverError;
  final String _networkError;

  @protected
  String entityError(Entity entity) {
    return entityErrorAI(entity, _serverError);
  }

  @protected
  String catchError(Object error) {
    return catchErrorAI(error, _requestError, _serverError, _networkError);
  }
}
