import 'package:jaguar_serializer/jaguar_serializer.dart';

part 'matter_data.jser.dart';

@GenSerializer()
class MatterDataSerializer extends Serializer<MatterData>
    with _$MatterDataSerializer {}

class MatterData {
  /// 我经办的
  static const int PROCESS_TYPE_DO = 0;

  /// 我发起的
  static const int PROCESS_TYPE_START = 1;

  /// 无状态
  static const int STATUS_TYPE_NULL = 0;

  /// 完成
  static const int STATUS_TYPE_FINISH = 1;

  /// 驳回
  static const int STATUS_TYPE_BACK = 2;

  /// 分页对象PID
  String pid;

  /// 内容
  List<String> contents;

  /// 事项类别
  int processType;

  /// 状态
  int status;

  /// 时间戳
  int timeMillis;

  /// 标题
  String title;
}
