abstract class TokenPersistor {
  static final TokenPersistor MEMORY = _MemoryTokenPersistor();

  Future<String> loadUserId();

  Future<String> loadToken();

  Future<bool> saveToken(String userId, String token);

  Future<bool> clear();
}

class _MemoryTokenPersistor implements TokenPersistor {
  String _userId;
  String _token;

  @override
  Future<String> loadUserId() async {
    return _userId;
  }

  @override
  Future<String> loadToken() async {
    return _token;
  }

  @override
  Future<bool> saveToken(String userId, String token) async {
    _userId = userId;
    _token = token;
    return true;
  }

  @override
  Future<bool> clear() async {
    _userId = null;
    _token = null;
    return true;
  }
}
